Last Comment Bug 724339 - text selection on mobile devices must support right-to-left (rtl) languages
: text selection on mobile devices must support right-to-left (rtl) languages
Status: VERIFIED FIXED
:
Product: Firefox for Android
Classification: Client Software
Component: Text Selection (show other bugs)
: Trunk
: ARM Android
: P1 enhancement with 1 vote (vote)
: Firefox 16
Assigned To: :Margaret Leibovic
:
Mentors:
Depends on:
Blocks: text-selection
  Show dependency treegraph
 
Reported: 2012-02-04 23:32 PST by Amir Aharoni
Modified: 2013-10-05 23:11 PDT (History)
8 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
verified
verified
fixed
+


Attachments
patch (7.93 KB, patch)
2012-06-22 15:06 PDT, :Margaret Leibovic
mbrubeck: review+
Details | Diff | Review

Description Amir Aharoni 2012-02-04 23:32:18 PST
Text selection doesn't exist on Fennec at this time at all. When it will be done, it must support right-to-left text selection. It works well in Safari on iPhone; it works more or less well on Opera, although the rendering of the selection background color is weird; it doesn't work in Webkit (on 2.3.4; it maybe be better in ICS).
Comment 1 Tomer Cohen :tomer 2012-02-05 07:31:01 PST
(In reply to Amir Aharoni from comment #0)
> it doesn't work in Webkit (on 2.3.4; it maybe be better in ICS).
It does work on WebKit (Browser/Android 2.3.7/Cyanogenmod), but it appears to not handle multiline selections correctly. 

As for Firefox, Firefox Beta on the same device does handle Right to left selection good enough.
Comment 2 Amir Aharoni 2012-02-05 07:34:29 PST
(In reply to Tomer Cohen :tomer from comment #1)
> (In reply to Amir Aharoni from comment #0)
> > it doesn't work in Webkit (on 2.3.4; it maybe be better in ICS).
> It does work on WebKit (Browser/Android 2.3.7/Cyanogenmod), but it appears
> to not handle multiline selections correctly. 

That's the point of this bug - if it doesn't handle multiline selection of right-to-left text correctly, then right-to-left text selection doesn't really work.
Comment 3 :Margaret Leibovic 2012-06-22 15:06:37 PDT
Created attachment 635937 [details] [diff] [review]
patch

(Based on top of my patch for bug 765072)

On an RTL page, the start handle is technically at the end of the selection, and vice versa. Our handle code doesn't need to know about that, but the code that sends mouse events to actually maintain the selection does.

For testing I used: http://people.mozilla.com/~mleibovic/test/lorem_ipsum_rtl.html
Comment 5 Ryan VanderMeulen [:RyanVM] 2012-06-23 19:56:14 PDT
https://hg.mozilla.org/mozilla-central/rev/594e394c497e
Comment 6 :Margaret Leibovic 2012-07-12 16:02:05 PDT
Uplifted to aurora as part of a roll-up patch:
https://hg.mozilla.org/releases/mozilla-aurora/rev/2fb0a358eaf6

Note You need to log in before you can comment on or make changes to this bug.